// IO.js


// open file for editing
function openFile() {
    if (inputFile.value != "") {
        try {
            var f = null;
            f = new File(inputFile.value);

            if (f.exists()) {
                doBackup();
                f.open();
                var fileData = f.read();

                content.value = fileData;
                setWindowTitle(inputFile.value);
                updateStatus("File opened...");
                addToHistory(inputFile.value);
                refreshPreview();
                f.close();
            } else {
                alert("The file does not exist.");
                return false;
            }
        } catch(e) {
            dump(e +"error in openFile");
            return false;
        }
    } else {
        alert("Please enter a valid file name to open.");
		return false;
    }
	return true;
}


// open file using filepicker
function openFilePicker() {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].
        createInstance( nsIFilePicker );
    fp.init( window, "Open File Dialog", nsIFilePicker.modeOpen );
	fp.appendFilter("Source Files","*.html; *.htm; *.xml; *.xul; *.rdf; *.css; *.dtd; *.php; *.js; *.jsp; *.asp; *.xhtml; *.shtml; *.java; *.cpp; *.pl");
	fp.appendFilters( nsIFilePicker.filterText | nsIFilePicker.filterAll);
    var res=fp.show();
    if (res==nsIFilePicker.returnOK){
        var thefile=fp.file;
	    updateStatus("Opening file with picker..");
	    inputFile.value = thefile.path;
	    openFile();
    }
}


// save file
function save() {
    if (inputFile != null && inputFile.value != "") {
        var f = new File(inputFile.value);
        if (content.value == null || content.value == "") {
            content.value=" ";
        }
        if (f.exists() && f.isFile()) {
            f.open('w');
			try {
				f.write(content.value);
				setModifiedState(false);
                doBackup();
                setWindowTitle(inputFile.value);
			} catch (e) {
			    dump("empty file created.");
				f.close();
				alert("An error occured and the file was not saved.");
				return;
			}
	        f.close();
		    updateStatus("File saved...");
        } else {
        try {
            f.create();
		} catch (e) {
		  dump("file not created in function save()");
		  alert("The file name or path is not valid.\nThe file was not saved.");
		  return false;
		}

	        if (f.exists() && f.isFile()) {
	            f.open('w');
	            f.write(content.value);
		setModifiedState(false);
		setWindowTitle(inputFile.value);
                doBackup();
	            updateStatus("File saved...");
		     } else {
	            alert("The file could not be saved.");
	         }
			 f.close();
			 return false;
        }
    } else {
        alert("Please enter a valid file name to save.");
    }
	return true;
}

// save file using filepicker
function saveFilePicker(hold) {
    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].
        createInstance( nsIFilePicker );
    fp.init( window, "Save File Dialog", nsIFilePicker.modeSave );
    fp.appendFilters( nsIFilePicker.filterText | nsIFilePicker.filterHTML |
	    nsIFilePicker.filterAll );
    var res=fp.show();
    if (res != nsIFilePicker.returnCancel){
        var thefile=fp.file;
	    updateStatus("Saving file..");
	    inputFile.value = thefile.path;
	    save();
        return true;
    } else if (hold != "") { //cancels close window event
        return false;
    }
    return false;
}

// Backup file on open
function doBackup() {
    if ( isBackup ) {
	    var u,f = null;
        u = new FileUtils();
		f = new File(inputFile.value);

		try {
		    if ( f.exists() ) {
			    u.remove(inputFile.value+"~");
			}
		    u.copy(inputFile.value,inputFile.value+"~");
		} catch(e) {
		    dump("File was not copied or deleted in doBackup()\n");
         	alert("An error occured and Auto backup could not backup your file.");
			return false;
		}
	}
	return true;
}



// remove backup files in current directory
function killBackups() {
    if ( inputFile.value == "" ) {
        alert("You need to open at least one file first before \nremoving backup files to set the directory.");
        return false;
    }
    if ( !confirm("Clicking okay will remove all Mozedit backup files in your current directory.\n"+
        "Mozedit backup files have the suffix ~. Do you want to continue?") ) {
        return false;
    }
    var f,fu,d = null;
    var fu = new FileUtils();
    var path = fu.parent(inputFile.value);
    var d = new Dir(path);

    try {
        var fileArray = d.readDir();

        if ( fileArray.length > 0 ) {
            for (x=0; x < fileArray.length; x++) {
                if ( fileArray[x].path.search(/~$/) == -1 ) {
                    continue;
                }
                try {
                    dump( "Removing backup files in killBackups(): \n"+fileArray[x].path + "\n");
                    var f = new File(fileArray[x].path);
                    if ( f.isFile) {
                        fu.remove(fileArray[x].path);
                    }
                } catch(e) {
                    dump(e+" Files could not be removed in killBackups()\n");
                    return false;
                }
            }
        }
        fileArray = null;
        return true;
    } catch(e) {
        dump(e+" error in killBackups()");
    }
}
